#!/usr/bin/perl -w
use strict;

my $Result = 1;

my $System_type = '';
my $Private_base = '';
my $lib = '';
use FindBin;
if ( -f $FindBin::Bin.'/env.pl' ) {
    require $FindBin::Bin.'/env.pl';
    $System_type = $env::System_type;
    $Private_base = $env::Private_base;
    $lib = $env::lib;
}
require $FindBin::Bin.'/list_modules.pl';
my @modules = (@list_modules::modules);

############################################################################
sub check_module
############################################################################
{
    print "Module $_[0] ... ";
    if ( list_modules::check_module($_[0]) ) {
        print "found!<br>\n";
    }
    else  {
        print "NOT FOUND!<br>\n";
        $Result = 0;
    }
}   ##check_module

print <<HTTPHEADER;
Status: 200 OK
Content-Type: text/html

HTTPHEADER
print <<HTML;
<html>
<head>
    <title>Checking Perl modules</title>
</head>
<body>
<h3>Checking Perl modules</h3>
<p>
Installer will check your Perl instance
for presense of modules required by AL Download Protection.
</p>
<p>
Search in Perl module path: @INC
</p>
HTML

#print "[[[@list_modules::modules]]]\n";
foreach my $mod (@modules) {
    check_module($mod);
}

if ( $Result ) {
    congratulations();
} else {
    instructions();
}


print <<HTML;
</body></html>
HTML

############################################################################
sub congratulations
############################################################################
{
    print <<HTML;
    <p>
    <table align=center border=1><tr><td align=center>
    <h3>Congratulations!</h3>
    All required Perl modules are present at the host.<br>
    AL Download Protection is ready to work.
    </td></tr></table>
HTML

}   ##congratulations

############################################################################
sub instructions
############################################################################
{
    print <<HTML;
    <p>
    <table align=center border=1><tr><td align=center>
    <h3>Attention!</h3>
    Some required Perl modules was not found at the host.<br>
    </td></tr><tr><td align=center>
    <h3>The following Perl modules must be installed at the host:</h3>
    @modules
    </td></tr><tr><td>
    To use AL Download Protection, you must add these modules to Perl instance.
    Please, do one of the following:
    <ul>
    <li><b>Prefered way:</b>
    Ask your provider or server administrator to install these module
    (or do this by yourself if you have administrative privileges at the host).
    <b>Note</b> that all required modules can be found in <em>required-unix.tar.gz</em>
    and <em>required-ppm.zip</em> archives. These archives contain CPAN and
    PPM packages respectively. You can
    <a href=http://software.anti-leech.com/index.php?go=download>download</a>
    these archives from Anti-Leech site.
    <p>&nbsp;
HTML

    if ( $System_type ne 'win' ) {
    print <<HTML;
    <li><b>Unix hosting users: </b>(Stealth install)
    Install missing modules into your private directory (other users of the host will not
    use the modules).<br>
    <b>To do this:</b> Download <em>required-unix.tar.gz</em> and put it into
    <em>alinstall</em> directory at the hosting host.<br>
    Then run module installer script
    (invoke: <a href=install_modules.pl>install_modules.pl</a>).<br>
    If your attempt failed, please, do not hesitate to contact
    <a href=mailto:support\@anti-leech.com>support\@anti-leech.com</a>.
    <p>&nbsp;
HTML
    }
    if ( $System_type ne 'unix' ) {
    print <<HTML;
    <li><b>Win32 hosting users: </b>(Stealth install)
    Install missing modules into your private directory (other users of the host will not
    use the modules).<br>
    <b>Warning:</b> This will work with ActivePerl v.5.6.x.6xx only.<br>
    <b>To do this:</b> Download and decompress <em>libwin.zip</em> archive
    and copy <em>lib\\...</em> tree from the archive into <em>lib</em> subfolder
    of the <em>private</em> directory (<em>$lib</em>).
    You can decompress the archive directly at
    the hosting host if you have terminal access to the host. Otherwise decompress
    the archive at your personal workstation and copy the tree to the host with
    a help of any advanced FTP client (CuteFTP, WS_FTP, Far; don't use command line ftp program,
    it is too difficult). <b>Important:</b> In both cases an original structure
    of the tree must be kept.<br>
    If your attempt failed or the hosting host is running other ActivePerl
    version, please, do not hesitate to contact
    <a href=mailto:support\@anti-leech.com>support\@anti-leech.com</a>.
    <p>&nbsp;
HTML
    }
    print <<HTML;
    </td></tr><tr><td align=center><p>&nbsp;<p>
    After completion of installation of Perl modules,<br> please run this
    script again to check that everything is ok:<br> invoke <a href=check_perl.pl>
    check_perl.pl</a> or press <b>Refresh</b> button.<p>&nbsp;
    </td></tr></table>
HTML
}   ##instructions
