package Package_DB;

use strict;
use Fcntl ':flock';
require "env.pl";
use sdep;


return "Ok";

########################################################
#Params:
#	package_name, rescramble period, referer list
########################################################
sub package_change
{
    my ($package, $expire, @ref) = @_;

    set_crypt_info($package, $expire, "1");
    set_referer_list($package,@ref);

    return "ok";
}



########################################################
# Params :
#	package_name
########################################################
sub package_delete
{
    my $package = $_[0];

    set_crypt_info($package,"","");
    set_referer_list($package,());
    return "ok";
}



########################################################
# Params :
#	package, @referer_list - update
#	package, () - clear
# Return
#	"" 	 fail
#	"ok"     ok
########################################################
sub set_referer_list
{
    my ($package, @ref)	= @_;

    if (!$package) { return "";}

    open (F, "+< $env::package_referer")  or die "Can't open : $!" ;
    binmode(F);
    flock(F, LOCK_EX);

    my $buf = "";
    while (<F>){
	if (!/^$package\t/) {
	    $buf .= $_;
	}
    }

    my $link;
    foreach $link (@ref) {
	$buf .= $package."\t".$link."\n";
    }

    seek (F, 0, 0) or die "Can't seek : $!";
#???    seek (F, 0, SEEK_SET) or die "Can't seek : $!";
    print F $buf or die "Can't print : $!";
    truncate (F, tell(F)) or die "Can't truncate : $!";
    close(F) or die "Can't close : $!";

    return "ok";
}



########################################################
# Params :
#	package
# Return
#	@referer_list	ok
#	()		fail
########################################################
sub get_referer_list
{
    my $package	= $_[0];

    if (!$package) { return ();}

    open (F, "< $env::package_referer")  or die "Can't open : $!" ;
    binmode(F);
    flock(F, LOCK_SH);

    my @ref;
    my ($pckg, $url, $tail);
    while (<F>){
	if (/^$package\t/) {
            ($pckg, $url) = split(/\t/ , $_);
	    ($url, $tail) = split (/\n/, $url);
	    $ref[++$#ref] = $url;
	}
    }

    close(F) or die "Can't close : $!";

    return @ref;
}


########################################################
# Params :
#     package, expire date, last crypt date - update
#     package, "", "" - remove
# Return
#	"" 	 fail
#	"ok"     ok
########################################################
sub set_crypt_info
{
    my $package	= $_[0];
    my $expire = $_[1];
    my $last_crypt = $_[2];

    if (!$package) { return "";}

    open (F, "+< $env::package_crypt")  or die "Can't open : $!" ;
    binmode(F);
    flock(F, LOCK_EX);

    my $buf = "";
    my $str = "\t\t\n"; #empty
    while (<F>){
	if (/^$package\t/) {
	    $str = $_;
	}
	else {
	    $buf .= $_;
	}
    }

    if ($expire or $last_crypt) {
	my ($pckg, $exp, $lst, $tail);

        ($pckg, $exp, $lst) = split(/\t/ , $str);
        ($lst, $tail) = split (/\n/, $lst);

	$exp = $expire || $exp || "";
	$lst = $last_crypt || $lst || "";
        $str = $package."\t".$exp."\t".$lst."\n";
        $buf .= $str;
    }

    seek (F, 0, 0) or die "Can't seek : $!";
#???    seek (F, 0, SEEK_SET) or die "Can't seek : $!";
    print F $buf or die "Can't print : $!";
    truncate (F, tell(F)) or die "Can't truncate : $!";
    close(F) or die "Can't close : $!";

    return "ok";
}



########################################################
# Params :
#     package
# Return :
#    array : expire date, last crypt date
########################################################
sub get_crypt_info()
{
    my $package	= $_[0];

    if (!$package) { return ("","");}

    open (F, "< $env::package_crypt")  or die "Can't open : $!" ;
    binmode(F);
    flock(F, LOCK_SH);

    my $str = "\t\t\n"; #empty
    while (<F>){
	if (/^$package\t/) {
	    $str = $_;
	    last;
	}
    }

    my ($pckg, $exp, $lst, $tail);

    ($pckg, $exp, $lst) = split(/\t/ , $str);
    ($lst, $tail) = split (/\n/, $lst);

    close(F) or die "Can't close : $!";

    return ($exp, $lst);
}


1;
