#!/usr/bin/perl -w
use strict;

use CGI;
use POSIX;

my $query = new CGI;

# find common environment - begin
BEGIN {
if ($ENV{SERVER_SOFTWARE} =~ /Microsoft-IIS/) {
my ($myPath, @myDir, $last, $catalog);
$myPath = $ENV{PATH_TRANSLATED};
if ($myPath ne "") {
   $myPath =~ s/\\/\//g; #/
   @myDir = split ("/", $myPath);
   $last = pop (@myDir);
   $catalog = join ('/', @myDir);
   $catalog =~ s/\//\\/g; #/
   push (@INC, $catalog);
};

};
require "env.pl";
};
# find common environment - end

use IO::Dir;

require "trigger.pm";
require "auth_chk.pm";
require "main_menu.pm";
require "my_subs.pm";
require "Package_DB.pm";

my  $auth_cookie=check_auth();
if($auth_cookie)
{

################################################################
print <<HTML;
<HTML><HEAD>
<title>Import exsisting packages</title>
<LINK REL="stylesheet" TYPE="text/css" HREF="$env::Css_file_path">
</HEAD><BODY>
HTML
main_menu ("import", "./");
################################################################

my $action = $query->param("action") || "";

if ($action eq "check") {
	import_check();
}
else {
	if ($action eq "import") {
		import_files();
	}else {
		import_default();
	}
}

################################################################
main_menu ("import", "./");
print "</BODY> </HTML>";
################################################################
} # auth_cookie


sub import_default
{
print <<HTML;
<p><div align=center>
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<form method="GET" action="import.pl">
<tr><td align=center class=hd>List of packages </td></tr>
<tr><td align=center class=hd> available for import</td></tr>
HTML

print_package_list("checkbox", "import", $env::Import_base);

print <<HTML;
<tr> <td align=center>
 <input type=submit value="OK">
 <input type=hidden name=action value=check>
</td> </tr>
</form>
</table> </td></tr > </table></div><p>
HTML
}



sub import_check
{
my @files = $query->param("import");
my @packages = get_packages();

my $file;
my $pack;
my $rewrite;

print <<HTML;
<p><div align=center>
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<form method="GET" action="import.pl">
<tr >
 <td align=center colspan=2 class=hd>Check the packages.<br>Some of them can overwrite prevoius content</td>
HTML

my_subs::even($my_subs::odd);
foreach $file (@files) {
	$rewrite = "";
	foreach $pack (@packages) {
		if ($pack eq $file) {
			$rewrite = "true";
		}
	}
	if ($rewrite) {
        print "<tr align=center><td class='$my_subs::odd'> $file <input type=hidden name=import value='$file'> </td> \n";
        print " <td class='$my_subs::odd'> <b>Overwrite ?</d> </td> </tr> \n";
	}else {
        print "<tr align=center><td class='$my_subs::odd'> $file <input type=hidden name=import value='$file'> </td> \n";
        print "<td class='$my_subs::odd'> <b>New</b> </td> </tr> \n";
	}
    my_subs::even($my_subs::odd);
}

print <<HTML;
<tr> <td align=center class='$my_subs::odd'>
 <input type=hidden name=action value='import'>
 <input  type=submit value="Continue">
</td>
</form>

<form method="GET" action="import.pl">
 <td align=center class='$my_subs::odd'>
 <input type=submit value="Back">
 </td> </tr>
</form>
</table></td></tr ></table></div><p>
HTML

}


sub import_files
{
	my @files = $query->param("import");
	my $file;
	my $origFile;
	my $newFile;
    my $error;
    my $origTemp;
    my $newTemp;

	print "<p><p><p><p> <div align=center>";
	foreach $file (@files) {
		$origFile = $env::Import_base.$env::Path_Delim.
			$file.$env::extension;
		$newFile = $env::Package_base.$env::Path_Delim.
			$file.$env::extension;

		$error = "";
		open (FD, "< $origFile") or $error = "Open for Read";
		open (NEWFD, "> $newFile") or $error += "Open for Write";
		while (<FD>) {
			print NEWFD "$_" or $error += "While write";
		}
		close (FD) or $error += "Close";
		close (NEWFD) or $error += "Close";
		if ($error) {
			print " Error with package $file <p>";
		} else {
			my_subs::update_db($file);
            print " Package $file imported <p>";
		}
        if ( !$error ) {
            # also copy template, if any
            $origTemp = $env::Import_base.$env::Path_Delim.
                $file.$env::extension_html;
            $newTemp = $env::Package_base.$env::Path_Delim.
                $file.$env::extension_html;
            if ( -f $origTemp ) {
                open (FD, "< $origTemp") or $error = "Open for Read";
                open (NEWFD, "> $newTemp") or $error += "Open for Write";
                while (<FD>) {
                    print NEWFD "$_" or $error += "While write";
                }
                close (FD) or $error += "Close";
                close (NEWFD) or $error += "Close";
                if ($error) {
                    print " Error with template for package $file <p>";
                } else {
                    print " Template for $file imported <p>";
                }
            }
        }
	}
	print "</div><p><p><p><p>";
	return "";
}

###############################################################################
# Param: type, name, dir, exstension
# Return: array of packages
###############################################################################
sub print_package_list
{
	my $type = $_[0];
	my $name = $_[1];
	my $dir_path = $_[2] || $env::Package_base;
	my $pack_ext = $_[3] || $env::extension;

	my @packages = get_packages($dir_path, $pack_ext);
	my $value;
	foreach $value (@packages) {
		my_subs::even ($my_subs::odd);
		print "<tr><td class=$my_subs::odd>\n";
		print "<input type='$type' name='$name' value='$value'>\n";
		print $value."</td></tr>\n";

	}

return "";
}

###############################################################################
# Param dir, exstension
# Return array of packages
###############################################################################
sub get_packages()
{
my $dir_path = $_[0] || $env::Package_base;
my $pack_extension = $_[1] || $env::extension;
my $len = length ($pack_extension);
my $pack_len;
my $ext;
my @files;

my $dir = new IO::Dir $dir_path;
if (defined $dir) {
	while (defined($_ = $dir->read)) {
		$pack_len = length ($_);
		if ($pack_len >  $len) {
			$ext = substr ($_, $pack_len-$len, $len);
		        if ($ext eq $pack_extension) {
				$files[++$#files] = substr ($_, 0, $pack_len-$len);
			}
		}
	}
	undef $dir;
}
return @files;
}
